import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ShopGoodsCategory, ShopGoodsCategoryParam } from './model';

/**
 * 分页查询商品分类
 */
export async function pageShopGoodsCategory(params: ShopGoodsCategoryParam) {
  const res = await request.get<ApiResult<PageResult<ShopGoodsCategory>>>(
    '/shop/shop-goods-category/page',
    params
  );
  if (res.code === 0) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 查询商品分类列表
 */
export async function listShopGoodsCategory(params?: ShopGoodsCategoryParam) {
  const res = await request.get<ApiResult<ShopGoodsCategory[]>>(
    '/shop/shop-goods-category',
    params
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 添加商品分类
 */
export async function addShopGoodsCategory(data: ShopGoodsCategory) {
  const res = await request.post<ApiResult<unknown>>(
    '/shop/shop-goods-category',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 修改商品分类
 */
export async function updateShopGoodsCategory(data: ShopGoodsCategory) {
  const res = await request.put<ApiResult<unknown>>(
    '/shop/shop-goods-category',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 删除商品分类
 */
export async function removeShopGoodsCategory(id?: number) {
  const res = await request.del<ApiResult<unknown>>(
    '/shop/shop-goods-category/' + id
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 批量删除商品分类
 */
export async function removeBatchShopGoodsCategory(data: (number | undefined)[]) {
  const res = await request.del<ApiResult<unknown>>(
    '/shop/shop-goods-category/batch',
    {
      data
    }
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 根据id查询商品分类
 */
export async function getShopGoodsCategory(id: number) {
  const res = await request.get<ApiResult<ShopGoodsCategory>>(
    '/shop/shop-goods-category/' + id
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}
